package com.sencorsta.rabs.obj.ai.scene.role;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;
import com.sencorsta.rabs.util.ResettableData;
import org.opencv.core.Point;

import java.awt.AWTException;

/**
 * 角色信息
 */
@SceneAnnotation("SceneMain")
public class SceneMain_Role_SkillPoint extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 3.1f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\role\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\role\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\role\\back.png";
    private static String PathBack2 = System.getProperty("user.dir") + "\\opencv\\scene\\role\\back2.png";
    private static String PathDropPoint = System.getProperty("user.dir") + "\\opencv\\scene\\role\\dropPoint.png";
    private static String PathSkill = System.getProperty("user.dir") + "\\opencv\\scene\\role\\skill.png";
    private static String PathLevel = System.getProperty("user.dir") + "\\opencv\\scene\\role\\level.png";
    private static String PathGoGet = System.getProperty("user.dir") + "\\opencv\\scene\\role\\goGet.png";
    private static String PathGet = System.getProperty("user.dir") + "\\opencv\\scene\\role\\get.png";
    private static String PathSkillGet = System.getProperty("user.dir") + "\\opencv\\scene\\role\\skillGet.png";
    private static String PathClose = System.getProperty("user.dir") + "\\opencv\\scene\\role\\close.png";
    @Override
    public void back() throws AWTException {
        moveToClick(PathBack, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                continue;
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @Override
    public void think() throws AWTException {
        ThreadUtil.sleep(3000);

        //点击等级最低的角色
        moveToClick(PathDropPoint, AiManage.getInstance().getCheckPoint(), new Point(0, 100));
        ThreadUtil.sleep(2000);

        moveToClick(PathLevel, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);

        moveToClick(PathSkill, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);

        moveToClick(PathGoGet, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);

        for (int i = 0; i < 3; i++) {
            if (checkHas(PathGet,AiManage.getInstance().getCheckPoint())){
                moveToClick(PathGet,AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(2000);
            }
        }
        moveToDrop(PathSkillGet,AiManage.getInstance().getCheckPoint(),new Point(0,300),new Point(0,80));
        ThreadUtil.sleep(2000);
        for (int i = 0; i < 2; i++) {
            if (checkHas(PathGet,AiManage.getInstance().getCheckPoint())){
                moveToClick(PathGet,AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(2000);
            }
        }

        getRecord().getData().setDone(true);
        //关闭退出
        moveToClick(PathClose, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);

        moveToClick(PathBack2, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public boolean isDone() {
        return getRecord().getData().isDone();
    }

    /**
     * 重置
     */
    @Override
    public ResettableData.ResetType getType(){
        return ResettableData.ResetType.HOUR_3;
    }

}
